function [optimised_sequence]=frequency_optimiseMAX(sequence_codon,sequence_amino,codon_ids,start_freq,end_freq);
%% Do the standard optimisation frequency by finding maximum rate codon and substituting that in.
optimised_sequence=sequence_codon;
for i=1:length(sequence_codon)
   current_amino=sequence_amino(i); 
    current_frequency=start_freq(sequence_codon(i));
    
    % Pick out which codons we might use, that have the same amino acid to
    % code
    choices=codon_ids(codon_ids(:,2)==current_amino,:);
  
    
    frequencies=end_freq(codon_ids(:,2)==current_amino);
    
    loc=find(frequencies==min(frequencies));
    
    % find locations of ones with the best match
    potential_swaps=choices(loc,1);
    if sum(potential_swaps==sequence_codon(i))==0 %If the best match is not the existing thing
 
        optimised_sequence(i)=choices(loc(1),1);

   
 
    elseif length(loc)>1
       % In this case the program realises multiples can be swapped out,
       % however we will leave the existing one in place/
    end


end


end