function trend_optimize_energy(start_standard_rate,sequence_codon,sequence_amino,codon_ids,start_organism_standard_rate,end_organism_standard_rate,avewidth,filename,GC_freq,start_GC_rate,outlawed_nums);
%% This function does the actual optimisation via the random process defined previously. 
attempt=0;
sequence=sequence_codon;
best_val=99999;
best_sequence=sequence;
sequence2=sequence;
target_rate=start_standard_rate;
target_GC_rate=start_GC_rate;
optimising=1;
    while optimising %just repeat this
        for offset=1:avewidth %Go through each offset

            [present_rate]=SpencerRateImplementB(sequence,end_organism_standard_rate,avewidth); 
           [present_GC_rate]=SpencerRateImplementB(sequence,GC_freq,avewidth)/3; 
            
            
            to_flip=offset:avewidth:length(sequence); %Select which ones we are going to flip in this time step
            target_flip_rate=target_rate(to_flip);
            present_flip_rate=present_rate(to_flip);
            
            for i=1:length(target_flip_rate)
                amino=sequence_amino(to_flip(i));
                codon_choices=codon_ids(find(codon_ids(:,2)==amino),1);
                 sequence2(to_flip(i))=codon_choices(randi(length(codon_choices),1,1));
             end
            [temp_rate]=SpencerRateImplementB(sequence2,end_organism_standard_rate,avewidth); 
            rate_diff_initial=smooth(abs(present_rate-start_standard_rate),avewidth);
            rate_diff_changed=smooth(abs(temp_rate-start_standard_rate),avewidth);
            
            [temp_GC_rate]=SpencerRateImplementB(sequence2,GC_freq,avewidth)/3; 
            GC_rate_diff_initial=smooth(abs(present_GC_rate-start_GC_rate),avewidth);
            GC_rate_diff_changed=smooth(abs(temp_GC_rate-start_GC_rate),avewidth);
            
            energy=(rate_diff_initial(to_flip)-rate_diff_changed(to_flip))+0.3*(GC_rate_diff_initial(to_flip)-GC_rate_diff_changed(to_flip));
            %% Scale the energy up if you like!
            energy=energy*1;

            diffs=1-exp(energy);
            superior_choices=or(energy>0,rand(size(diffs))<diffs);
            
            
            sequence(to_flip(superior_choices))=sequence2(to_flip(superior_choices)); 
            
            sequence2=sequence;
            
            
        end
        %% Now fix any points which are outlawed due to iGEM rules

        %sequence=fix_outlawed(sequence,outlawed_nums,end_organism_standard_rate,codon_ids);

        %% Move on to spencer rate
        [present_rate]=SpencerRateImplementB(sequence,end_organism_standard_rate,avewidth); 
         [present_GC_rate]=SpencerRateImplementB(sequence,GC_freq,avewidth)/3; 
         
            if sum(abs(start_standard_rate-present_rate))<best_val
                best_sequence=sequence;
                csvwrite(filename,best_sequence);
                best_val=sum(abs(start_standard_rate-present_rate));
%                          %% Plot
                if 1
                    subplot(2,1,1)
                    plot(start_standard_rate)
                    hold on
                    plot(present_rate)
                    hold off
                    legend('Target','Optimised')
                    xlabel('Codon location')
                    ylabel('Rate')
                    subplot(2,1,2)
                    plot(start_GC_rate)
                    hold on
                    plot(present_GC_rate)
                    hold off
                    
                    legend('Target','Optimised')
                    xlabel('Codon location')
                    ylabel('GC Richness')
                    title(['Sequence after ',num2str(attempt),' optimisation attempts'])
                    
                    attempt=attempt+1;
                    if attempt==50
                        in=input('50 optimisation attempts completed, input 1 to finish or 0 to proceed.');
                        if in
                            optimising=0;
                        end
                    end
                    pause(0.1)
                end
                
            else 
                sequence=best_sequence;
                sequence2=best_sequence;
            end
    end
end